setwd("C:/Users/knapp/Documents/Guido/GemischteModelle/Datenstze")
BtheB <- read.table("BtheB.txt", header=TRUE)
head(BtheB)
BtheB$subject <- factor(rownames(BtheB))

# Datensatz von "weit" auf "lang"
nobs <- nrow(BtheB)
BtheB_long <- reshape(BtheB, idvar = "subject",
         varying = c("bdi.2m", "bdi.3m", "bdi.5m", "bdi.8m"),
         direction = "long")
BtheB_long$time <- rep(c(2, 3, 5, 8), rep(nobs,4))
head(BtheB_long)
#
library(lme4)
# Random Intercept Model
BtheB_lmer1 <- lmer(bdi ~ bdi.pre + time + treatment + drug + length
               + (1 | subject), data = BtheB_long,
               REML = FALSE, na.action = na.omit)
# Random Intercept and Random Slope Model
BtheB_lmer2 <- lmer(bdi ~ bdi.pre + time + treatment + drug + length
               + (1 + time | subject), data = BtheB_long,
               REML = FALSE, na.action = na.omit)
anova(BtheB_lmer1, BtheB_lmer2)
#
# Dss einfachere Modell reicht aus
summary(BtheB_lmer1)
update(BtheB_lmer1, REML=TRUE)

# Ein Ausflug in die Multiplen Vergleiche
library(multcomp)
cftest(BtheB_lmer1)

# Normalverteilungsannahme der zuflligen Effekte gerechtfertigt?
layout(matrix(1:2, ncol = 2))
# BLUPs fr den Intercept
qint <- ranef(BtheB_lmer1)$subject[["(Intercept)"]]
# Gesamtresiduen
qres <- residuals(BtheB_lmer1)
# Erster Q-Q-Plot
qqnorm(qint, ylab = "Estimated random intercepts", xlim = c(-3,3),
             ylim = c(-20, 20), main = "Random intercepts")
qqline(qint)
# Zweiter Q-Q-Plot
qqnorm(qres, xlim = c(-3,3), ylim = c(-20, 20),
             ylab = "Estimated residuals",
             main = "Residuals")
qqline(qres)

# Geht hier die Analyse auch mit der Funktion lme im Paket nlme?

